6339d2925166da48276d12e21b3f253c3498923b
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.5
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # See the README file for information about the dependencies
19 # this script has.
20
21 ##############################################################################################
22 # Global Variables
23 ##############################################################################################
24 typeset cmd="$0 $*"
25 typeset dvdname=""
26 typeset debug=""
27 typeset dest=""
28 typeset isofile=""
29 typeset vobfile=""
30 typeset dvdpath=""
31 typeset aspect=""
32 typeset SCALE=""
33 typeset CROP=""
34 typeset profile="xvidhq"
35 typeset extension=""
36 typeset mailto=""
37 typeset encoder=""
38 typeset default_alang="en"
39 typeset track=""
40 typeset drc="0.0"
41 typeset -i default_aid=128
42 typeset -i aid_override=-1
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_video_bitrate=2000
57 typeset -i target_audio_bitrate=224
58 typeset -i target_size=0
59 typeset -i audio_2ch=0
60 typeset -i audio_6ch=1
61 typeset -i invalid_feature_title=0
62 typeset -i feature_title_override=0
63 typeset -i mplayer_dumpstream_incompatibility=0
64 typeset -i lsdvd_incompatibility=0
65 typeset -i custom_video_bitrate=0
66 typeset -i custom_audio_bitrate=0
67 typeset -i custom_audio_2ch=0
68 typeset -i custom_audio_6ch=0
69 typeset -i minimum_feature_title_length=10
70 typeset -i lsdvd_timeout=10
71
72 ##############################################################################
73 # Local Machine Settings:
74 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
75 # and the local conf file created by each local machine (rip_dvd.conf)
76 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
77 # This will allow you to override all the default values to meet your needs
78 # in a way that won't get clobbered when you pull updates from my GIT repo.
79 ##############################################################################
80 config="${0%/*}/rip_dvd.conf"
81
82 # The config file will be searched for in the following location order:
83 found_config=0
84
85 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
86 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
87
88 # 2) /path/to/rip_dvd/script/rip_dvd.conf
89 [ -e "${config}" ] && found_config=1 && . "${config}"
90
91 # 3) /etc/rip_dvd.conf
92 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
93
94 # 4) $PWD/rip_dvd.conf
95 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
96
97 # Check to make sure we found the config file
98 if [ $found_config -eq 0 ]; then
99   echo "-E- Unable to find the rip_dvd.conf file: $config"
100   exit 1
101 fi
102
103 ##############################################################################################
104 # Command line processing
105 ##############################################################################################
106 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:B:s:t:a:p:e:j:l:r: opt "$@"
107 do
108     case $opt in
109         (n)     dvdname=$OPTARG;;
110         (d)     dest=$OPTARG;;
111         (b)     target_video_bitrate=$OPTARG; custom_video_bitrate=1;;
112         (B)     target_audio_bitrate=$OPTARG; custom_audio_bitrate=1;;
113         (s)     target_size=$OPTARG;;
114         (2)     audio_2ch=1; custom_audio_2ch=1;;
115         (6)     audio_6ch=1; custom_audio_6ch=1;;
116         (1)     force_onepass_mode=1;;
117         (v)     make_final_dest_vob=1;;
118         (i)     make_final_dest_iso=1;;
119         (f)     make_final_dest_folder=1;; 
120         (z)     make_final_dest_comp=1;;
121         (e)     encoder=$OPTARG;;
122         (m)     mirror_mode=1;;
123         (k)     keep_intermediate_files=1;;
124         (t)     feature_title_override=$OPTARG;;
125         (a)     aspect=$OPTARG;;
126         (p)     profile=$OPTARG;;
127         (x)     extension=$OPTARG;;
128         (j)     eject_disk=$OPTARG;;
129         (l)     aid_override=$OPTARG;;
130         (r)     drc=$OPTARG;;
131         (w)     set -x;;
132         (h)     show_usage=1;;
133         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
134         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
135     esac
136 done
137
138 shift $((OPTIND-1))
139
140 function usage() {
141     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
142     echo >&2 "Revision $REV"
143     echo >&2 "Options:"
144     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
145     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
146     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
147     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
148     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
149     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
150     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
151     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
152     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
153     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
154     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
155     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
156     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
157     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
158     echo >&2 "                 Handbrake Only Encoder Profiles:"
159     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
160     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
161     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
162     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
163     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
164     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
165     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
166     echo >&2 "                 The default operation is non-mirror mode where only the main"
167     echo >&2 "                 feature title will be ripped."
168     echo >&2 "   -v            Make the final image a DVD VOB file"
169     echo >&2 "   -i            Make the final image a DVD ISO file"
170     echo >&2 "   -f            Make the final image a DVD folder"
171     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
172     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
173     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
174     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
175     echo >&2 "   -b <bitrate>  Set the video bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
176     echo >&2 "   -B <bitrate>  Set the audio bitrate desired in the compressed file in kbits/sec (ex: 96, 128, 160, 224 (default), 300, etc)"    
177     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
178     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
179     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
180     echo >&2 "   -j <n>        Eject the disk:"
181     echo >&2 "                 - 0 = do not eject the disk"
182     echo >&2 "                 - 1 = eject after the entire script is done (default)"
183     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
184     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
185     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
186     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
187     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
188     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
189     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
190     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
191     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
192     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
193     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
194     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
195     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
196     echo >&2 ""
197     exit 2
198 }
199
200 if (($errors)) || (($show_usage))
201 then
202   usage
203 fi
204
205 # Sanity Check - Command Line Options 
206 if [ "$dest" == "" ]; then
207   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
208   usage
209 fi
210
211 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
212    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
213     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
214     make_final_dest_comp=1
215 fi
216
217 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
218   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
219   usage
220 fi
221
222 if [ $target_video_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
223   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
224   usage
225 fi
226
227 if [ $mirror_mode -eq 1 ]; then
228   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
229      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
230     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
231     usage
232   fi
233 fi
234
235 # Make handbrake the default encoder if not specified and we can find it
236 if [ -z "$encoder" ]; then
237   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
238   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
239   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
240   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
241   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
242 fi
243
244 # Sanity check the profile selection
245 if [[ "$encoder" == "mencoder" ]]; then
246   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
247 fi
248
249 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
250   echo "-E- Invalid encoder specified: $encoder"
251   exit 1
252 fi
253
254 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
255 if [ "$aspect" != "" ]; then
256   echo "$aspect" | grep -q "x"
257   if [ $? == 0 ]; then
258     echo "-E- You must specify the aspect option with a value whose format is W:H"
259     exit 1
260   fi
261   echo "$aspect" | grep -q ":"
262   if [ $? != 0 ]; then
263     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
264     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
265   else
266     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
267     if [ "$encoder" == "handbrake" ]; then
268        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
269        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
270        SCALE="-w $WIDTH -l $HEIGHT"
271     fi
272   fi
273 fi
274
275 # Sanity Check - Key executables
276 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
277 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
278 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
279 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
280 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
281 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
282 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
283 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
284 [[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
285 [[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
286 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
287 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
288 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
289 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
290 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
291
292 ##############################################################################################
293
294 typeset -i ripdvd
295 if [ -z "$dvdname" ]; then
296
297   # make sure the DVD device is accessible
298   volname $dev > /dev/null 2>&1
299   if [ $? != 0 ]; then
300     echo "-E- Can't access the DVD device $dev"
301     exit 1
302   fi
303   # now capture the volume name from the device
304   dvdname=`volname $dev | awk '{ print $1 }'`
305   ripdvd=1
306
307 else 
308
309   # check to see if dvdname is a full path to a real directory
310   # if it is, set dvdname and dvdpath appropriately
311   if [ -d "$dvdname" ]; then
312     dvdpath="$dvdname"
313     dvdname=`basename "$dvdname"`
314     keep_dvdfolder=1
315     if [ -z "$dvdname" ]; then
316      echo "-E- Unable to extract dvdname from path: $dvdpath"
317      exit 1
318     fi
319     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
320       echo "-E- You must supply a full path to a valid DVD folder with this option"
321       exit 1
322     fi
323   fi
324
325   # Check to see if dvdname is a full path to a file
326   if [ -f "$dvdname" ]; then
327     valid_file=0
328
329     # check to see if dvdname is a full path to an MPG2 (VOB) file
330     # if it is, set dvdname and vobfile appropriately
331     file "$dvdname" | grep -q "MPEG"
332     if [ $? == 0 ]; then
333       # It is a valid MPEG2 file, now strip the extension off our dvdname
334       vobfile="$dvdname"
335       dvdname=`basename "$dvdname"`
336       dvdname=${dvdname%.[^.]*}
337       keep_vobfile=1
338       valid_file=1
339     fi
340
341     # check to see if dvdname is a full path to an ISO file
342     # if it is, set dvdname and isofile appropriately
343     file "$dvdname" | grep -q -e "ISO" -e "UDF"
344     if [ $? == 0 ]; then
345       # It is a valid ISO file, now strip the extension off our dvdname
346       isofile="$dvdname"
347       dvdname=`basename "$dvdname"`
348       dvdname=${dvdname%.[^.]*}
349       keep_isofile=1
350       valid_file=1
351     fi    
352
353     # check to see if dvdname is a full path to an ISO file
354     # if it is, set dvdname and isofile appropriately
355     file "$dvdname" | grep -q -e "VOB"
356     if [ $? == 0 ]; then
357       # It is a valid VOB file, now strip the extension off our dvdname
358       vobfile="$dvdname"
359       dvdname=`basename "$dvdname"`
360       dvdname=${dvdname%.[^.]*}
361       keep_vobfile=1
362       valid_file=1
363     fi    
364
365     # If we didn't find a handler for the file above, complain
366     if [ $valid_file -eq 0 ]; then
367       echo "-E- Unsupported file type: $vobfile"
368       exit 1
369     fi
370
371   # Throw an error if we can't find what the -n option is pointing to
372   else 
373     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
374     exit 1
375   fi
376
377   # Set the ripdvd flag to false since we aren't ripping a DVD disk
378   ripdvd=0
379
380   # Since we aren't ripping a DVD disk, don't eject anything either
381   eject_disk=0
382
383 fi
384
385 # remove bad characters from the dvdname
386 dvdname=${dvdname%.} # remove trailing '.' character
387
388 # add the suffix extension to the end of the dvdname
389 dvdname=$dvdname$extension
390
391 # make a "safe" dvdname (remove special characters)
392 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
393
394 # Make sure we have a non-empty dvdname
395 if [ -z "$dvdname" ]; then
396   echo "-E- unable to determine dvdname"
397   exit 1
398 fi
399
400 # make sure our vobfile value is set
401 if [ -z "$vobfile" ]; then
402   vobfile="$dest/$dvdname.VOB"
403 fi
404
405 # set up some variables to hold various logfiles
406 logfile="$logdir/$dvdname.log"
407 passlogfile="$tmpdir/$safedvdname.log"
408 ddrescuelog=`tempfile`
409 dvdauthorlog=`tempfile`
410 encodelog=`tempfile`
411 dumplog=`tempfile`
412
413 # create the tmpdir if it doesn't already exist
414 if [ ! -d "$tmpdir" ]; then
415   mkdir -p "$tmpdir"
416   if [ $? != 0 ]; then
417     echo "-E- Unable to create the tmpdir: $tmpdir"
418     exit 1
419   fi
420 fi
421
422 # create the logdir if it doesn't already exist
423 if [ ! -d "$logdir" ]; then
424   mkdir -p "$logdir"
425   if [ $? != 0 ]; then
426     echo "-E- Unable to create the logdir: $logdir"
427     exit 1
428   fi
429 fi
430
431 ##############################################################################################
432 # cleanup functions
433 ##############################################################################################
434 cleanup() { 
435   if [ $keep_intermediate_files -eq 0 ]; then
436     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
437     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
438     [[ -e "$encodelog" ]] && rm -f "$encodelog"
439     [[ -e "$dumplog" ]] && rm -f "$dumplog"
440   else
441     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
442     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
443     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
444     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
445   fi
446   echo ""
447 }
448
449 fatal_and_exit() {
450   if [[ -z "$1" ]]; then
451     msg="-E- control-c killed us"
452   else
453     msg=$1
454   fi
455   echo -e 2>&1 "$msg" | tee -a "$logfile"
456   if [[ -n "$mailto" ]]; then
457     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
458   fi
459   keep_intermediate_files=1
460   exit 1
461 }
462
463 # Call our cleanup functions on INT and EXIT signals
464 trap fatal_and_exit INT
465 trap cleanup EXIT
466
467 ##############################################################################################
468 # processing functions
469 ##############################################################################################
470
471 function alarm() { perl -e 'alarm shift; exec @ARGV' "$@"; }
472
473 function lsdvd_longest_title {
474   dev="$1"
475
476   # Only use lsdvd to extract the longest feature title if we didn't detect an incompatibility earlier
477   if [ $lsdvd_incompatibility -eq 1 ]; then
478     invalid_feature_title=1
479     return
480   fi
481
482   # Try the normal lsdvd command to see if it works
483   alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
484   if [ $? != 0 ]; then
485     # lsdvd didn't work
486     invalid_feature_title=1
487     lsdvd_incompatibility=1
488     return
489   fi
490  
491   # lsdvd is good to go, use it
492   feature_title=`lsdvd $dev 2>/dev/null | awk '/Longest/ { print $NF }'`
493 }
494
495 function lsdvd_css {
496   dev="$1"
497
498   # Try the normal lsdvd command to see if it works
499   alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
500
501   if [ $? != 0 ]; then
502     # lsdvd didn't work. Try VLC.
503     lsdvd_incompatibility=1
504     if [[ -x `which cvlc` ]]; then 
505       echo "-> lsdvd failed to DeCSS the DVD. Trying VLC: $dev" | tee -a "$logfile"
506       alarm $lsdvd_timeout cvlc --no-video --no-audio $dev  >> "$logfile" 2>&1
507       # Once you get a DVD that VLC can't handle, figure out how 
508       # to detect that here and abort.
509       #if [ $? != 1 ]; then
510       #  echo "-> VLC failed to decss the DVD."
511       #  return 1
512       #fi
513     else
514       fatal_and_exit "-E- lsdvd failed to DeCSS the DVD. VLC not found, but required to rip this DVD."
515     fi
516   fi
517   return 0
518 }
519
520 # encode the vob file into a compressed file format using handbrake
521 function encode_vob_file_handbrake {
522   
523   # declare some globals
524   typeset handbrake_cli=""
525   typeset handbrake_video_encoder_opts=""
526   typeset filetype=""
527   typeset handbrake_audio_opts=""
528   typeset hb_profile=""
529   typeset SIZE=""
530   typeset AUDIO_BITRATE=""
531
532   # Set a variable that we will use later to determine if we found a handler for $profile or not
533   typeset -i found_profile=0    
534
535   # For a given profile, to override the 2 pass behavior to be single pass,
536   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
537   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
538   PASSES="-2"
539
540   # Set our DRC option
541   DRC="-D $drc"
542
543   if [ $target_size -ne 0 ]; then
544     SIZE="-S $target_size"
545   fi 
546
547   if [ $custom_audio_bitrate -eq 1 ]; then
548     AUDIO_BITRATE="-B $target_audio_bitrate"
549   fi
550
551   if [ $force_onepass_mode -eq 1 ]; then
552     PASSES=""
553   fi
554
555   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
556   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
557
558   # XVID profile
559   if [[ "$profile" =~ "xvid" ]]; then
560     found_profile=1
561     handbrake_cli="$handbrake_xvid"
562     final_output_file="$dest/$dvdname.avi"
563     filetype="avi"
564
565     # Very High Quality (16fps)
566     if [ "$profile" == "xvidvhq" ]; then
567       handbrake_opts[0]="-f avi"
568       handbrake_opts[1]="-b $target_video_bitrate"
569       handbrake_opts[2]="-e xvid"
570       handbrake_opts[3]="-T"
571       handbrake_opts[4]="-5"
572       handbrake_opts[5]="-8"
573     fi
574     # High Quality (20fps)
575     if [ "$profile" == "xvidhq" ]; then
576       handbrake_opts[0]="-f avi"
577       handbrake_opts[1]="-b $target_video_bitrate"
578       handbrake_opts[2]="-e ffmpeg"
579       handbrake_opts[3]="-T"
580       handbrake_opts[4]="-5"
581     fi
582     # Fast (28fps)
583     if [ "$profile" == "xvid" ]; then
584       handbrake_opts[0]="-f avi"
585       handbrake_opts[1]="-b $target_video_bitrate"
586       handbrake_opts[2]="-e ffmpeg"
587       handbrake_opts[3]="-T"
588     fi
589   fi
590
591   # MP4 profile
592   if [[ "$profile" =~ "mp4" ]]; then
593     found_profile=1
594     handbrake_cli="$handbrake_mp4"
595     final_output_file="$dest/$dvdname.mp4"
596     PASSES=""
597
598     # Handle custom parameter overrides
599     if [ $custom_video_bitrate == 1 ]; then
600       handbrake_opts[0]="-b $target_video_bitrate"
601     fi
602     if [ $custom_audio_2ch == 0 ]; then
603       audio_2ch=0
604     fi
605     if [ $custom_audio_6ch == 0 ]; then
606       audio_6ch=0
607     fi
608
609     # Very High Quality
610     if [ "$profile" == "mp4vhq" ]; then
611       profile="hb_High_Profile"
612     fi
613     # High Quality
614     if [ "$profile" == "mp4hq" ]; then
615       profile="hb_Normal"
616     fi
617     # Fast
618     if [ "$profile" == "mp4" ]; then
619       profile="hb_Classic"
620     fi
621   fi
622
623   # iphone and ipod MP4 profiles
624   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
625     found_profile=1
626     handbrake_cli="$handbrake_mp4"
627     final_output_file="$dest/$dvdname.mp4"
628     PASSES=""
629
630     # Handle custom parameter overrides
631     if [ $custom_video_bitrate == 1 ]; then
632       handbrake_opts[0]="-b $target_video_bitrate"
633     fi
634     if [ $custom_audio_2ch == 0 ]; then
635       audio_2ch=0
636     fi
637     if [ $custom_audio_6ch == 0 ]; then
638       audio_6ch=0
639     fi
640
641     # iphone
642     if [ "$profile" == "iphone" ]; then
643       profile="hb_iPhone_&_iPod_Touch"
644     fi
645     # ipod
646     if [ "$profile" == "ipod" ]; then
647       profile="hb_iPod"
648     fi
649
650   fi
651   
652   # Predefined Handbrake Profile Handling
653   if [[ "$profile" =~ "hb" ]]; then
654     found_profile=1
655     handbrake_cli="$handbrake_mp4"
656     final_output_file="$dest/$dvdname.mp4"
657     PASSES=""
658
659     # Handle custom parameter overrides
660     if [ $custom_video_bitrate == 1 ]; then
661       handbrake_opts[0]="-b $target_video_bitrate"
662     fi
663     if [ $custom_audio_2ch == 0 ]; then
664       audio_2ch=0
665     fi
666     if [ $custom_audio_6ch == 0 ]; then
667       audio_6ch=0
668     fi
669     
670     # extract the HandBrake Profile name from $profile
671     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
672   fi
673
674   # Make sure we found a handler for the given profile
675   if [ $found_profile -eq 0 ]; then
676     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
677   fi
678
679   # setup our audio option
680   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
681     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
682   fi
683   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
684     handbrake_audio_opts="-E ac3 -6 auto"
685   fi
686   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
687     handbrake_audio_opts="-E faac -6 dpl2"
688   fi
689   if [ -n "$track" ]; then
690     handbrake_audio_opts="$handbrake_audio_opts -a $track"
691   fi
692
693   # Convert our array of opts into a string
694   for OPTS in "${video_encoder_opts[@]}"; do 
695     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
696   done
697   if [ -n "$handbrake_video_encoder_opts" ]; then
698     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
699   fi
700   for OPTS in "${handbrake_opts[@]}"; do 
701     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
702   done
703
704   # Append "global" command line options
705   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
706   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
707   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
708   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
709   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
710   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $AUDIO_BITRATE"
711
712   # Execute the handbrake command to encode the video
713   # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
714   # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
715   if [ -n "$hb_profile" ]; then
716     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
717     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
718     handbrake_retval=$?
719   else 
720     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
721     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
722     handbrake_retval=$?
723   fi
724   if [ $handbrake_retval != 0 ]; then
725     fatal_and_exit "-E- Unhandled handbrake error"
726   fi
727
728   # Concatenate the encode log to our main log file, greping out unwanted lines
729   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
730   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
731   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
732 }
733
734 # encode the vob file into a compressed file format using mencoder
735 function encode_vob_file_mencoder {
736
737   # Set a variable that we will use later to determine if we found a handler for $profile or not
738   typeset -i found_profile=0
739
740   # For a given profile, to override the 2 pass behavior to be single pass,
741   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
742   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
743   PASSES="1 2"
744
745   # Declare our default 2 pass variables
746   passlogfile_opt="-passlogfile $passlogfile"
747   pass_opt="pass=%PASS"
748
749   # Check the global force_onepass_mode. If it is set, change our variables appropriately
750   # to force 1-pass encoding across all profiles.
751   if [ $force_onepass_mode -eq 1 ]; then
752     PASSES="2"
753     passlogfile_opt=""
754     pass_opt=""    
755   fi
756
757   # XVID profile
758   if [[ "$profile" =~ "xvid" ]]; then
759     found_profile=1
760     final_output_file="$dest/$dvdname.avi"
761     mencoder_general_opts="$lang_opts $passlogfile_opt"
762     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
763     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
764     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
765
766     # Very High Quality (16fps)
767     if [ "$profile" == "xvidvhq" ]; then
768       video_encoder_opts[0]="bitrate=$target_video_bitrate"
769       video_encoder_opts[1]="threads=$mencoder_threads"
770       video_encoder_opts[2]="chroma_opt"
771       video_encoder_opts[3]="vhq=4"
772       video_encoder_opts[4]="bvhq=1"
773       video_encoder_opts[5]="quant_type=mpeg"
774       video_encoder_opts[6]="autoaspect"
775     fi
776     # High Quality (20fps)
777     if [ "$profile" == "xvidhq" ]; then
778       video_encoder_opts[0]="bitrate=$target_video_bitrate"
779       video_encoder_opts[1]="threads=$mencoder_threads"
780       video_encoder_opts[2]="chroma_opt"
781       video_encoder_opts[3]="vhq=2"
782       video_encoder_opts[4]="bvhq=1"
783       video_encoder_opts[5]="quant_type=mpeg"
784       video_encoder_opts[6]="autoaspect"
785     fi
786     # Fast (28fps)
787     if [ "$profile" == "xvid" ]; then
788       video_encoder_opts[0]="bitrate=$target_video_bitrate"
789       video_encoder_opts[1]="threads=$mencoder_threads"
790       video_encoder_opts[2]="vhq=0"
791       video_encoder_opts[3]="turbo"
792       video_encoder_opts[4]="autoaspect"
793     fi
794
795     for OPTS in "${video_encoder_opts[@]}"; do 
796       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
797     done
798
799     if [ $audio_2ch -eq 0 ]; then
800       # These options produce good 6 channel audio for linux and windows
801       mencoder_audio_opts="-oac copy"
802       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
803       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
804       mencoder_audioch_opts[1]="-af channels=6"
805       mencoder_audioch_opts[2]=""
806     else
807       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
808       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$target_audio_bitrate"
809       mencoder_audioch_opts[0]=""
810     fi
811  
812   fi
813
814   # iphone and ipod MP4 profiles
815   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
816     found_profile=1
817     if [ "$profile" == "iphone" ]; then
818       # SCALE: 480x320
819       # scale width to 480, set height appropriately, but keep a multiple of 16
820       #SCALE=",scale=480:-10"
821       # scale the video down however far is necessary to fit in 480x320
822       SCALE=",dsize=480:320:0,scale=-8:-8"
823     else
824       # SCALE: 320x240
825       # scale width to 320, set height appropriately, but keep a multiple of 16
826       #SCALE=",scale=320:-10"
827       # scale the video down however far is necessary to fit in 320x240
828       SCALE=",dsize=320:240:0,scale=-8:-8"
829     fi
830     final_output_file="$dest/$dvdname.mp4"
831     mencoder_general_opts="$lang_opts $passlogfile_opt"
832     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
833     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
834     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
835     video_encoder_opts[0]="bitrate=$target_video_bitrate"
836     video_encoder_opts[1]="threads=$mencoder_threads"
837     video_encoder_opts[2]="vbv_maxrate=1500"
838     video_encoder_opts[3]="vbv_bufsize=2000"
839     video_encoder_opts[4]="nocabac"
840     video_encoder_opts[5]="me=umh"
841     video_encoder_opts[6]="subq=6"
842     video_encoder_opts[7]="frameref=6"
843     video_encoder_opts[8]="trellis=1"
844     video_encoder_opts[9]="level_idc=30"
845     video_encoder_opts[10]="global_header"
846     video_encoder_opts[11]="bframes=0"
847     video_encoder_opts[12]="partitions=all"
848     for OPTS in "${video_encoder_opts[@]}"; do 
849       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
850     done
851
852     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$target_audio_bitrate:raw"
853     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
854   fi
855
856   if [ $found_profile -eq 0 ]; then
857     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
858   fi
859
860   # Do not edit this line. $mencoder_video_encoder_opts must be last
861   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
862   mencoder_retval=0
863
864   for PASS in $PASSES
865   do 
866     # Set some options based on which pass we are in
867     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
868     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
869     [ $PASS -eq 1 ] && output_file="/dev/null"
870     [ $PASS -eq 2 ] && output_file="$final_output_file"
871   
872     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
873     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
874     do
875       echo -e "   Encoding pass $PASS"
876       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
877       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
878       mencoder_retval=$? 
879       grep -q "\[channels\] Invalid" $encodelog
880       if [ $? != 0 ]; then          
881         break;
882       else
883         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
884       fi
885     done
886       
887     if [ $mencoder_retval != 0 ]; then
888       fatal_and_exit "-E- Unhandled mencoder error"
889     fi
890
891     # Concatenate the encode log to our main log file, greping out unwanted lines
892     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
893
894   done
895 }
896
897 function make_dvd_iso_image {
898
899   isofile="$1"
900
901   # check to see if we have a dvdpath to rip from instead of $dev
902   if [ -z "$dvdpath" ]; then
903     # load the CSS codes in the DVD drive 
904     lsdvd_css "$dev"
905     if [ $? != 0 ]; then
906       fatal_and_exit "-E- lsdvd $dev failed" 
907     fi
908
909     # read the DVD, ignoring/skipping CRC errors
910     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
911     if [ $? != 0 ]; then
912       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
913     fi
914     cat "$ddrescuelog" >> "$logfile"
915   else
916     # rip from a path instead
917     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
918   fi
919 }
920
921 function make_dvd_iso_image_from_folder {
922   
923   src="$1"
924   dst="$2"
925   handle_error=$3
926   
927   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
928
929   # make an iso image out of our directory
930   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
931   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
932
933   # set the audio languages from the iso if it exists and is non-zero in size
934   if [ -s "$dst" ]; then
935     get_feature_title "$dst"
936     get_audio_id_from_iso "$dst"
937   fi
938
939   # make sure we were able to create the iso image from the folder given to us
940   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
941     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
942     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
943     # remove the bad iso file
944     [[ -e "$dst" ]] && rm -f "$dst"
945     # get the feature title from the DVD folder
946     get_feature_title "$dvdpath"
947     # create our main VOB file from the ISO
948     create_main_vob_with_mplayer "$dvdpath" 
949     # get our audio id from the VOB file
950     get_audio_id_from_vob "$vobfile"
951   fi
952 }
953
954 function make_dvdbackup_folder_image {
955   # extract the feature title from the DVD image
956   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
957   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
958   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
959   if [ $? != 0 ]; then
960     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
961   fi
962 }
963
964 function make_dvdauthor_folder_image {
965   # create a new DVD video of the feature title
966   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
967   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
968   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
969   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
970
971   # There is a chance that dvdauthor won't like some of the VOBs.
972   # We can't tell ahead of time which ones it will choke on. 
973   # So, we need to run it over and over again until it can process
974   # all the VOBs. If it can't handle one of them, run it through
975   # mencoder to fix it and try again. These errors are typically
976   # present due to the copy protection that ddrescue removed.
977   grep -q "SCR moves" $dvdauthorlog
978   while [ $? == 0 ]; do
979     # fix bad vobs that get the "SCR moves backwards" error:
980     #  STAT: Processing VTS_01_0.VOB...
981     #  ERR:  SCR moves backwards, remultiplex input.
982     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
983     if [[ ! -f "$badvob" ]]; then
984       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
985     fi
986     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
987     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
988     mv -f $badvob.fixed $badvob
989     echo "-> Creating DVD video $dest/$dvdname"
990     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
991     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
992     grep -q "SCR moves" $dvdauthorlog
993   done
994 }
995
996 function get_feature_title {
997   source="$1"
998   # if a feature title was given on the command line, use it
999   if [ $feature_title_override -ne 0 ]; then
1000     feature_title=$feature_title_override
1001     return 0
1002   fi
1003   # otherwise, use lsdvd to figure it out
1004   if [ $ripdvd -eq 1 ]; then
1005     lsdvd_longest_title "$dev" 
1006   else 
1007     lsdvd_longest_title "$source"
1008   fi
1009 }
1010
1011 function create_main_vob_with_cat {
1012   # cd to the feature title DVD folder
1013   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1014   if [ $? != 0 ]; then
1015     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1016   fi
1017
1018   # concatenate all the VOBs together into 1 giant VOB
1019   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
1020   cat $vobs > "$tmpdir/$dvdname.VOB"
1021
1022   # cd back to the dir we started from
1023   popd > /dev/null 2>&1
1024 }
1025
1026 function create_main_vob_with_mplayer {
1027
1028   # argument processing  
1029   source="$1"
1030   remove_dumplog=$2
1031
1032   # make sure we have a valid feature title
1033   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
1034     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
1035   fi
1036
1037   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
1038   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
1039     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
1040     msg="$msg We also detected a condition that may require you to use dumpstream. "
1041     msg="$msg\n    Unable to rip this DVD in the mode you requested."
1042     fatal_and_exit "$msg"
1043   fi
1044
1045   # use mplayer to create the main VOB file
1046   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
1047   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1048   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
1049   if [ $? != 0 ]; then
1050     cat $dumplog | grep -v "^A:" >> "$logfile"
1051     fatal_and_exit "-E- Mplayer Failed"
1052   fi
1053   cat $dumplog | grep -v "^A:" >> "$logfile"
1054   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
1055 }
1056
1057 function get_audio_id_from_iso {
1058   # Adjust our audio ID to find the english audio stream
1059   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1060   iso="$1"
1061   aidcheck=`tempfile`
1062   aid=$default_aid
1063   alang=$default_alang
1064   if [ $aid_override -lt 0 ]; then 
1065     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1066     grep -q "aid: $aid" $aidcheck
1067     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1068       (( aid = aid + 1 ))
1069       grep -q "aid: $aid" $aidcheck
1070     done
1071     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1072   else
1073     aid=$aid_override
1074   fi
1075   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1076   # mencoder default DVD audio track language selection (english)
1077   lang_opts="-aid $aid -alang $alang"
1078 }
1079
1080 function get_crop_from_iso { 
1081   FRAMES=10000
1082   echo "-> Detecting black frame border crop value from ISO file"
1083   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1084   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1085   [[ -e "md5sums" ]] && rm -f "md5sums"
1086   CROP=`cat $dumplog | grep CROP | tail -1`
1087   echo "   Found crop value of $CROP" >> "$logfile"
1088   CROP=${CROP#* crop=}
1089   CROP=${CROP%%\).*}
1090   typeset -i CROPCHECK
1091   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1092   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1093   if [ -z "$CROP" ]; then
1094     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1095     return
1096   fi
1097   if [ $CROPCHECK -lt 0 ]; then 
1098     CROP=""
1099   else 
1100     CROP=",crop=$CROP"
1101   fi
1102   echo "   Setting mencoder crop filter to: $CROP"
1103 }
1104
1105 function get_crop_from_vob { 
1106   FRAMES=10000
1107   echo "-> Detecting black frame border crop value from VOB file"
1108   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1109   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1110   [[ -e "md5sums" ]] && rm -f "md5sums"
1111   CROP=`cat $dumplog | grep CROP | tail -1`
1112   echo "   Found crop value of $CROP" >> "$logfile"
1113   CROP=${CROP#* crop=}
1114   CROP=${CROP%%\).*}
1115   typeset -i CROPCHECK
1116   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1117   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1118   if [ -z "$CROP" ]; then
1119     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1120     return
1121   fi
1122   if [ $CROPCHECK -lt 0 ]; then 
1123     CROP=""
1124   else 
1125     CROP=",crop=$CROP"
1126   fi
1127   echo "   Setting mencoder crop filter to: $CROP"
1128 }
1129
1130 function get_audio_track_from_vob {
1131   # Adjust our audio ID to find the english audio stream
1132   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1133   vob="$1"
1134   handbrake_cli="$2"
1135   aidcheck=`tempfile`
1136   aid=$default_aid
1137   alang=$default_alang
1138   if [ $aid_override -lt 0 ]; then 
1139     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1140     grep -q "Found audio stream: $aid" $aidcheck
1141     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1142       (( aid = aid + 1 ))
1143       grep -q "Found audio stream: $aid" $aidcheck
1144     done
1145     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1146   else 
1147     aid=$aid_override
1148   fi
1149   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1150
1151   # convert the aid we found into hex
1152   aid_hex=`echo "obase=16; $aid" | bc`
1153   
1154   # extract the audio streams in the vob
1155   #ffmpeg -i "$vob" > $aidcheck 2>&1
1156   $handbrake_cli --stop-at duration:1 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1157   
1158   # find the stream that matches our aid
1159   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1160   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1161   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1162  
1163   # extract the track number that handbrake uses
1164   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1165   track=`expr match "$stream" '^\([0-9]*\):'`
1166
1167   if [ -n "$track" ]; then   
1168     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1169   fi
1170 }
1171
1172 function get_audio_id_from_vob {
1173   # Adjust our audio ID to find the english audio stream
1174   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1175   vob="$1"
1176   aidcheck=`tempfile`
1177   aid=$default_aid
1178   alang=$default_alang
1179   if [ $aid_override -lt 0 ]; then 
1180     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1181     grep -q "Found audio stream: $aid" $aidcheck
1182     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1183       (( aid = aid + 1 ))
1184       grep -q "Found audio stream: $aid" $aidcheck
1185     done
1186     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1187   else 
1188     aid=$aid_override
1189   fi
1190   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1191   # mencoder default DVD audio track language selection (english)
1192   lang_opts="-aid $aid -alang $alang"
1193 }
1194
1195 function check_vob_for_corrupted_start {
1196   # check to see if the beginning of the DVD has a form of copy protection
1197   # where they have deliberately broken the first X number of frames of the DVD.
1198   # If we don't skip these, our resulting VOB file will not play.
1199   badvobcheck=`tempfile`
1200   endpos=360
1201   skip=0
1202   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1203   if [ $? != 0 ]; then
1204     fatal_and_exit "-E- Mencoder Failed"
1205   fi
1206   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1207   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1208     (( skip = skip + 5 ))
1209     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1210     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1211     if [ $? != 0 ]; then
1212       fatal_and_exit "-E- Mencoder Failed"
1213     fi
1214     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1215   done
1216   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1217
1218   # cat the giant VOB into mencoder to create a playable VOB file
1219   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1220   if [ $? != 0 ]; then
1221     fatal_and_exit "-E- Mencoder Failed"
1222   fi
1223 }
1224
1225 function check_vob_for_completeness {
1226   # check to make sure we got out a complete VOB.
1227   # there is another kind of copy protection where the VOB's may
1228   # have "MPG EOF" frames in the middle of the stream. 
1229   # this causes mencoder to not process the entire VOB, and exit without any errors.
1230   # detect this by seeing how much smaller the dst vob is from the src vob.
1231   MAX_FILESIZE_DELTA_PERCENT=70
1232   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1233   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1234   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1235   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1236     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1237     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1238     create_main_vob_with_mplayer "$isofile"
1239     [[ -e "$dumplog" ]] && rm -f $dumplog
1240     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1241     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1242     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1243       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1244     fi
1245   fi
1246 }
1247
1248 function check_vob_for_too_many_video_packets {
1249   # If our earlier algorithm to work around this failed, throw an error.
1250   # check to see if this DVD has a protection scheme we don't know how to work around
1251   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1252   # for some reason, the video is black, while the audio rolls, then the video finally comes
1253   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1254   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1255   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1256   grep -q "Too many video packets in the buffer:" "$logfile"
1257   if [ $? == 0 ]; then
1258     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1259     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1260     create_main_vob_with_mplayer "$isofile"
1261     grep -q "Too many video packets in the buffer:" $dumplog
1262     if [ $? == 0 ]; then
1263       [[ -e "$dumplog" ]] && rm -f $dumplog
1264       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1265     fi
1266     [[ -e "$dumplog" ]] && rm -f $dumplog
1267   fi
1268 }
1269
1270 function check_vob_for_a52_crc_errors {
1271   # Let's see if we can playback our newly created VOB file without any errors.
1272   # if there are issues, let's detect them now, and try to recreate the VOB
1273   # there are some forms of copy protection that have missed above, that evidence
1274   # themselves when we try to playback the VOB file. This was added to deal with
1275   # the "a52: CRC check failed" copy protection scheme.
1276   MAX_ERRORS=10
1277   ENDPOS=120
1278   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1279   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1280   cat $dumplog | grep -v "^A:" >> "$logfile"
1281   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1282   if [ $errors -gt $MAX_ERRORS ]; then
1283     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1284     create_main_vob_with_mplayer "$isofile"
1285     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1286     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1287     if [ $? != 0 ]; then
1288       cat $dumplog | grep -v "^A:" >> "$logfile"
1289       fatal_and_exit "-E- Mplayer Failed"
1290     fi
1291     cat $dumplog | grep -v "^A:" >> "$logfile"
1292     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1293     if [ $errors -gt $MAX_ERRORS ]; then
1294       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1295     fi
1296   fi
1297   [[ -e "$dumplog" ]] && rm -f $dumplog
1298 }
1299
1300 function calculate_bitrate_from_target_size {
1301   # determine what our bitrate needs to be if a target size was specified instead
1302   if [ $target_size -ne 0 ] && [ $custom_video_bitrate -eq 0 ]; then
1303     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1304     ((min_length = minimum_feature_title_length * 60))
1305     if [[ $vob_length -gt $min_length ]]; then 
1306       ((target_video_bitrate = (target_size * 1024 * 8) / vob_length ))
1307       custom_video_bitrate=1
1308       echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_video_bitrate kbits/sec" | tee -a "$logfile"
1309     else
1310       echo "-W- Unable to determine the real length of this DVD feature title." | tee -a "$logfile"
1311       echo "    A target bitrate from the target_size requested will not be set." | tee -a "$logfile"
1312       echo "    If using handbrake, only the target_size will be passed to the encoder." | tee -a "$logfile" 
1313       echo "    If using mencoder, the target_size will be entirely disregarded." | tee -a "$logfile"
1314       echo "    You may need to rerun with the -b option with a target bitrate to get the desired size." | tee -a "$logfile"
1315       if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
1316         fatal_and_exit "-E- You'll need rip this DVD with the handbrake encoder and an MP4 type profile to get a good rip."
1317       fi
1318     fi
1319   fi
1320 }
1321
1322 function create_dvdauthor_dvd_xml_file {
1323   # make a dvdauthor xml menu file to create a valid DVD video from 
1324   # this script does a good job, but we'll still need to clean it up a bit after it runs
1325   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1326   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1327   if [ $? != 0 ]; then
1328     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1329   fi
1330
1331   # replace the first line of the xml file to remove the bad dest path
1332   awk -v line=1 -v new_content="<dvdauthor>" '{
1333     if (NR == line) {
1334       print new_content;
1335     } else {
1336       print $0;
1337     }
1338   }' dvd.xml > dvd.xml.new
1339   mv -f dvd.xml.new dvd.xml
1340   if [ $? != 0 ]; then
1341     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1342   fi
1343
1344   # remove the "<video " property line from the xml file
1345   cat dvd.xml | grep -v "<video" > dvd.xml.new
1346   mv -f dvd.xml.new dvd.xml
1347   if [ $? != 0 ]; then
1348     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1349   fi
1350   
1351   # remove the extra <pgc>..</pgc> pairs
1352   cat dvd.xml | awk 'BEGIN {x=1}
1353   {
1354     if ($0~"</pgc>") {x=0}
1355     if (x==1) {print $0}
1356     if ($0~"<pgc>") {x=1}
1357   }' > dvd.xml.new
1358   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1359   mv -f dvd.xml.new dvd.xml
1360   if [ $? != 0 ]; then
1361     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1362   fi
1363
1364   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1365   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1366   mv -f dvd.xml.new dvd.xml
1367   if [ $? != 0 ]; then
1368     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1369   fi
1370 }
1371
1372 function check_for_mplayer_dumpstream_incompatibility {
1373
1374   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1375
1376   # Check to see if the DVD had any lsdvd incompatibilities
1377   if [ $lsdvd_incompatibility -eq 1 ]; then
1378     invalid_feature_title=1
1379     echo "-E- Unable to determine the feature title due to an lsdvd inability to DeCSS" | tee -a "$logfile"
1380     echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1381     echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"    
1382     return
1383   fi
1384
1385   if [ ! -e "$vobfile" ]; then
1386     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1387     # A DVD that has 99 titles, where the longest title isn't the main feature
1388     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1389     # out what the feature title is. This script will run through that flow if we
1390     # set use_mplayer_dumpstream to 0. Check for this here.
1391     if [ $ripdvd -eq 1 ]; then
1392       alarm $lsdvd_timeout lsdvd $dev | grep -q "Title: 99"
1393     else
1394       alarm $lsdvd_timeout lsdvd "$isofile" | grep -q "Title: 99"
1395     fi
1396     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1397     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1398       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1399         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1400         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1401         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1402         invalid_feature_title=1
1403       else 
1404         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1405         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1406         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1407         use_mplayer_dumpstream=0
1408         invalid_feature_title=1
1409       fi
1410       return
1411     fi
1412   fi
1413
1414   # There is another form of protection that causes the mplayer dumpstream to fail. 
1415   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1416   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1417   # problem before continuing.
1418   if [ -e "$vobfile" ]; then
1419     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1420     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1421     grep -q "Too many audio packets in the buffer" $dumplog
1422     if [ $? == 0 ]; then
1423       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1424       use_mplayer_dumpstream=0
1425       mplayer_dumpstream_incompatibility=1
1426     fi
1427     [[ -e "$dumplog" ]] && rm -f $dumplog
1428   fi
1429
1430   # There is another form of protection that causes the mplayer dumpstream to fail.
1431   # The resulting VOB file looks complete, but has something in it that causes mplayer/mencoder 
1432   # to be unable to encode it since it thinks the entire VOB is only a few minutes long in length.
1433   # Using HandBrake with an MP4 type profile can work around this, but mencoder or Handbrake with XVID profile won't.
1434   if [ -e "$vobfile" ]; then
1435     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1436     ((min_length = minimum_feature_title_length * 60))
1437     if [[ $vob_length -lt $min_length ]]; then 
1438       if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
1439         echo "-E- The main feature title that was ripped from the DVD has an invalid movie length." | tee -a "$logfile"
1440         echo "    You'll need rip this DVD with the handbrake encoder and an MP4 type profile instead." | tee -a "$logfile"
1441         mplayer_dumpstream_incompatibility=1
1442         fatal_and_exit "-E- Aborting encoding step due to invalid movie length."
1443       fi
1444     fi
1445   fi
1446 }
1447
1448 function fill_mythvideo_metadata {
1449
1450   # This function must be passed the filename as an argument
1451   # The filename must be a full path to the file
1452   filename="$1"
1453
1454   # Make sure the fill mythvideo metadata option has been set to 1
1455   if [ $fill_mythvideo_metadata -eq 0 ]; then
1456     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1457     return 0
1458   fi
1459
1460   # If the fill mythvideo metadata script is present, run it
1461   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1462   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1463     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1464     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1465   else
1466     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1467     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1468   fi
1469 }
1470
1471 # remove the intermediate VOB file
1472 function remove_intermediate_vob_file {
1473   if [ $keep_intermediate_files -eq 0 ]; then
1474     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1475   else
1476     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1477   fi
1478 }
1479
1480 # remove the original DVD image 
1481 function remove_intermediate_iso_file {
1482   [[ $keep_isofile -eq 1 ]] && return 1
1483   if [ $keep_intermediate_files -eq 0 ]; then
1484     [[ -e "$isofile" ]] && rm "$isofile"
1485   else
1486     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1487   fi
1488 }
1489
1490 # remove the intermediate dvdbackup folder
1491 function remove_intermediate_dvdbackup_folder {
1492   if [ $keep_intermediate_files -eq 0 ]; then
1493     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1494   else
1495     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1496   fi
1497 }
1498
1499 ##############################################################################################
1500 # MAIN
1501 ##############################################################################################
1502
1503 # Make a note of when this DVD rip started
1504 date=`date`
1505 echo -e "\n$date DVD rip started" >> "$logfile"
1506 echo "$cmd" >> "$logfile"
1507
1508 # Rip the DVD - Mirror Mode
1509 if [ $mirror_mode -eq 1 ]; then
1510   echo "-> Ripping DVD $dvdname to $dest"
1511
1512   # use ddrescue to make an ISO image of the disk
1513   make_dvd_iso_image "$dest/$dvdname.iso"
1514
1515   # add this video data to the mythtv DB
1516   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1517
1518   # eject the disk upon completion
1519   if [ $eject_disk -ne 0 ]; then
1520     eject -T $dev
1521   fi
1522
1523   date=`date`
1524   echo "$date DVD rip completed" | tee -a "$logfile"
1525
1526   if [[ -n "$mailto" ]]; then
1527     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1528   fi
1529
1530 fi
1531
1532 # Rip the DVD - Main Title Feature Only
1533 if [ $mirror_mode -eq 0 ]; then
1534
1535   # Rip image from DVD
1536   if [ $ripdvd -eq 1 ]; then
1537     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1538     # use ddrescue to make an ISO image of the disk
1539     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1540   fi
1541
1542   # Rip image from DVD path
1543   if [ -n "$dvdpath" ]; then
1544     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1545     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1546   fi
1547
1548   # make sure our isofile value is set
1549   if [ -z "$isofile" ]; then
1550     isofile="$tmpdir/$dvdname.iso"
1551   fi
1552      
1553   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1554
1555     if [ ! -e "$vobfile" ]; then
1556       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1557       
1558       # get the feature title from the ISO
1559       get_feature_title "$isofile"
1560  
1561       # get the crop value from the ISO
1562       get_crop_from_iso
1563
1564       # check for mplayer dumpstream incompatibilities
1565       # if they exist, this method will set this mode to 0.
1566       check_for_mplayer_dumpstream_incompatibility
1567
1568       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1569
1570         # get our audio id from the ISO file
1571         get_audio_id_from_iso "$isofile"
1572
1573         # create our main VOB file from the ISO
1574         create_main_vob_with_mplayer "$isofile"
1575      
1576         # remove the intermediate VOB file
1577         remove_intermediate_vob_file
1578
1579         # it's possible that our VOB is still corrupted in some manner
1580         # check to make sure it is still a good VOB before continuing.
1581         check_for_mplayer_dumpstream_incompatibility
1582
1583       fi
1584  
1585       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1586
1587         # use dvdbackup to make a DVD folder of the feature title
1588         make_dvdbackup_folder_image
1589   
1590         # create our main VOB file
1591         create_main_vob_with_cat
1592
1593         # get our audio id from the VOB file
1594         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1595   
1596         # check for corrupted VOB start
1597         check_vob_for_corrupted_start
1598  
1599         # check to make sure our VOB is complete
1600         check_vob_for_completeness
1601
1602         # check to make sure our VOB doesn't have too many video packets
1603         check_vob_for_too_many_video_packets
1604
1605         # check to make sure our VOB doesn't have a52 crc errors
1606         check_vob_for_a52_crc_errors
1607
1608         # remove the intermediate VOB file
1609         remove_intermediate_vob_file
1610
1611       fi
1612
1613       # remove the intermediate ISO file
1614       remove_intermediate_iso_file
1615
1616     else
1617       if [ "$encoder" != "handbrake" ]; then 
1618         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1619         # get our audio id from the VOB file
1620         get_audio_id_from_vob "$vobfile"
1621         # get the crop value from the VOB
1622         get_crop_from_vob
1623       fi
1624     fi
1625
1626     # eject the DVD disk since we are finished with it
1627     [ $eject_disk -eq 2 ] && eject -T $dev
1628
1629     # encode the VOB file to a compressed file format
1630     if [ $make_final_dest_comp -eq 1 ]; then
1631       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1632
1633       # determine what our bitrate needs to be if a target size was specified instead
1634       calculate_bitrate_from_target_size        
1635      
1636       # encode the vob file into a compressed file format
1637       if [[ "$encoder" == "mencoder" ]]; then 
1638         encode_vob_file_mencoder
1639       fi
1640       if [[ "$encoder" == "handbrake" ]]; then
1641         encode_vob_file_handbrake
1642       fi
1643
1644       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1645         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1646         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1647       else
1648         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1649         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1650       fi
1651     fi
1652
1653   # add this video data to the mythtv DB
1654   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1655   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1656     
1657   else
1658
1659   # use dvdbackup to make a DVD folder of the feature title
1660   make_dvdbackup_folder_image
1661
1662   # cd to the feature title DVD folder
1663   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1664   if [ $? != 0 ]; then
1665     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1666   fi
1667   
1668   # create the dvd.xml file for dvdauthor
1669   create_dvdauthor_dvd_xml_file  
1670
1671   # make the final DVD folder image
1672   make_dvdauthor_folder_image
1673
1674   # add this video data to the mythtv DB
1675   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1676  
1677   # cd back to the dir we started from
1678   popd > /dev/null 2>&1
1679
1680   if [ $make_final_dest_iso -eq 1 ]; then
1681
1682     # make an iso image out of our directory
1683     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1684    
1685     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1686     if [ -s "$dest/$dvdname.iso" ]; then
1687       if [ $make_final_dest_folder -eq 0 ]; then
1688         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1689         # remove the folder of the DVD image now that we have a .iso version of it
1690         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1691       fi
1692     else
1693       # we created an empty iso file, remove it
1694       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1695       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1696       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1697     fi
1698  
1699     # add this video data to the mythtv DB
1700     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1701
1702   fi
1703
1704   fi
1705
1706   # remove the ddrescue DVD ISO image
1707   remove_intermediate_iso_file
1708
1709   # remove the tmp dvdbackup folder of the DVD image
1710   remove_intermediate_dvdbackup_folder
1711
1712   # eject the DVD disk upon completion
1713   [ $eject_disk -eq 1 ] && eject -T $dev
1714
1715   date=`date`
1716   echo "$date DVD rip completed" | tee -a "$logfile"
1717
1718   if [[ -n "$mailto" ]]; then
1719     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1720   fi
1721
1722 fi
1723
1724 ##############################################################################################